extends Node

const _debug_scene_arrow := preload("res://debug_arrow.tscn")

func draw_arrow(pos1 : Vector3, pos2: Vector3, color : Color = Color.white, time : float = 1.0, delay : float = 0.0):
	var debug_scene = _debug_scene_arrow.instance()
	add_child(debug_scene)
	debug_scene.set_translation(pos1)
	if (pos2-pos1).normalized() == Vector3.UP:
		debug_scene.set_translation(pos1)
		debug_scene.set_rotation(Vector3(PI/2,0,0))
	else:
		debug_scene.look_at_from_position(pos1, pos2, Vector3.UP)
	debug_scene.set_scale(Vector3(1, 1, pos1.distance_to(pos2)))
	var mesh : MeshInstance = debug_scene.get_node("MeshInstance")
	var mat : Material = mesh.get_active_material(0).duplicate()
	mat.set_albedo(color)
	mesh.set_surface_material(0, mat) # material_override?
	if delay > 0.0:
		debug_scene.set_visible(false)
		var timer_delay := Timer.new()
		debug_scene.add_child(timer_delay)
		timer_delay.timeout.connect(debug_scene.set_visible.bind(true))
		timer_delay.set_wait_time(delay)
		timer_delay.start()
		
	var timer_free := Timer.new()
	debug_scene.add_child(timer_free)
	timer_free.connect("timeout", mesh, "set_surface_material", [0, null]) # material_override?
	timer_free.connect("timeout", debug_scene, "queue_free")
	timer_free.set_wait_time(delay+time)
	timer_free.start()
